<?
// Обновление базы из maxmind v. 1.1
//
// Скачайте базу в CSV-формате:
// http://geolite.maxmind.com/download/geoip/database/GeoIPCountryCSV.zip
// http://www.maxmind.com/app/geolitecity
//
// Распакуйте архивы и скопируйте файлы GeoIPCountryWhois.csv и GeoLiteCity-Blocks.csv в эту папку

// Подключаемся к базе данных
require_once ("./db.php");

define ("MAX_CITY_ID", 438386); // ID последнего города в базе maxmind на момент сборки 

// Загружаем справочник кодов стран
$codes = array();
$sql = "select * from net_country";
$result = mysql_query($sql);
while ($row = mysql_fetch_array($result)) {
    $codes[$row['code']] = $row['id'];
}

// Обновляем страны
$fp = fopen ("./GeoIPCountryWhois.csv", "r");
if ($fp) {
    // Удаляем все старые записи
    mysql_query("truncate net_country_ip");
    $added = 0;
    $page = "";
    $insert = "";
    $count = 0;
    while (!feof($fp)) {
        $page .= fgets($fp, 1024);
        $pos = strpos($page, "\n");
        while ($pos !== false) {
            if ($pos > 0) {
                $line = substr ($page, 0, $pos);
                $page = substr($page, $pos + 1);
                if (preg_match("#^\"[^\"]+\",\"[^\"]+\",\"(\d+)\",\"(\d+)\",\"([^\"]+)\",\"([^\"]+)\"$#", $line, $match)) {
                    $begin_ip = $match[1];
                    $end_ip = $match[2];
                    $country_code = $match[3];
                    if (array_key_exists($country_code, $codes)) {
                        $country_id = $codes[$country_code];
                        if ($count == 0) {
                            $insert = "insert ignore into net_country_ip (begin_ip, end_ip, country_id) values ('$begin_ip', '$end_ip', '$country_id')";
                        } else {
                            $insert .= ", ('$begin_ip', '$end_ip', '$country_id')";
                        }
                        $count++;
                        // Добавляем с заданной задержкой
                        if ($count == 500) {
                            mysql_query($insert) or die($insert);
                            $count = 0;
                            $insert = "";
                        }
                        $added++;
                    }
                }
            }
            $pos = strpos ($page, "\n");
        }
    }
    // Добавляем последние записи
    if ($insert) {
        mysql_query($insert) or die($insert);
    }
    echo "Added countries blocks: $added\n";
} else {
    die("Error: GeoIPCountryWhois.csv not found\n");
}
fclose ($fp);

// Обновляем города
$fp = fopen ("./GeoLiteCity-Blocks.csv", "r");
if ($fp) {
    // Удаляем все старые записи
    mysql_query("truncate net_city_ip");
    // Добавляем временное поле
    mysql_query("alter table net_city_ip add column `verified` bit(1) default 0") or die (mysql_error());
    mysql_query("alter table net_city_ip add index `verified` (`verified`)");
    $count = 0;
    $insert = "";
    $page = "";
    while (!feof($fp)) {
        $page .= fgets($fp, 1024);
        $pos = strpos($page, "\n");
        while ($pos !== false) {
            if ($pos > 0) {
                $line = substr ($page, 0, $pos);
                $page = substr($page, $pos + 1);
                if (preg_match("#^\"(\d+)\",\"(\d+)\",\"(\d+)\"$#", $line, $match)) {
                    $begin_ip = $match[1];
                    $end_ip = $match[2];
                    $city_id = $match[3];
                    // Проверяем существование города в базе
                    if ($city_id <= MAX_CITY_ID) {
                        if ($count == 0) {
                            $insert = "insert ignore into net_city_ip (begin_ip, end_ip, city_id) values ('$begin_ip', '$end_ip', '$city_id')";
                        } else {
                            $insert .= ", ('$begin_ip', '$end_ip', '$city_id')";
                        }
                        $count++;
                        // Добавляем с заданной задержкой
                        if ($count == 500) {
                            mysql_query($insert) or die($insert);
                            $count = 0;
                            $insert = "";
                        }
                    }
                }
            }
            $pos = strpos ($page, "\n");
        }
    }
    // Добавляем последние записи
    if ($insert) {
        mysql_query($insert) or die($insert);
    }
    // Отмечаем блоки проверенных городов
    $sql = "select * from net_city";
    $result = mysql_query($sql);
    while ($row = mysql_fetch_array($result)) {
        $city_id = $row['id'];
        $usql = "update net_city_ip set `verified`=1 where city_id=$city_id";
        mysql_query($usql) or die($usql);
    }
    // Перебрасываем города с дублей
    $sql = "select * from net_t_dub";
    $result = mysql_query($sql);
    while ($row = mysql_fetch_array($result)) {
        $from_id = $row['from_id'];
        $to_id = $row['to_id'];
        $usql = "update net_city_ip set city_id=$to_id, `verified`=1 where city_id=$from_id";
        mysql_query($usql) or die($usql);
    }
    // Удаляем лишние блоки
    $sql = "delete from net_city_ip where `verified`=0";
    mysql_query($sql);
    // Удаляем временное поле
    mysql_query("alter table `net_city_ip` drop column `verified`");
    // Оптимизируем таблицу, чтобы было красиво
    mysql_query("optimize table net_city_ip");
    // Статистика
    $sql = "select count(*) as c from net_city_ip";
    $result = mysql_query($sql);
    $row = mysql_fetch_array($result);
    echo "Added cities blocks: $row[c]\n";
} else {
    die("Error: GeoLiteCity-Blocks.csv not found\n");
}
fclose ($fp);

?>